/*
* This plugin combines many Marine vs Marine features
* - Players and buildings are now Blue vs Red (new models)
* - Red team is able to respawn
*
* Credits:
*	Sandstorm		-	rip from his ava for scoreboard fix
*	CheesyPeteza		-	his Respawn System
*	DarK_SouL		-	his fix of CheesyPeteza	Respawn System and winning message change
*	Zamma & White Panther	-	mvmmodels plugin
*		mahnsawce	-	rip off from MvM Auto Glow plugin and his weld fix
*	CorDorMick		-	testing
*	-mE-			-	idea for code performance
*	Depot			-	his assistance in getting bugs fixed
*
*	by White Panther
*
* v1.0:
*	- initial release
*
* v1.1.3:
*	- fixed prob where models were precached on all combat maps instead of only on mvm combat (mahnsawce)
*	- fixed bug where players respawned and model has not been changed
*	- error with unknown players should be fixed
*
* v1.2.3:
*	- fixed:
*		- possible error
*		- error with unknown players
*		- plugin was not running on maps where CC was on team 2 instead of 3
*	- added:
*		- ability to autoassign players (default off) (amx_mvm_auto 1/0)
*	- changes:
*		- moved from ns2amx to engine + fakemeta + ns
*
* v1.2.9c:
*	- fixed:
*		- bug where red teams scoreboard was green while players where reinforcing
*		- players could have default (green) model until they died or got JP/HA
*		- red players could spectate through eyes of blue players when dead
*		- another default model bug
*		- changed the way of getting command chairs and armorys to improve speed (thx -mE-)
*	- added:
*		- respawn display added
*	- changes:
*		- the new temp command chair (red team) will get all pevs from the original copied
*		- the way of getting the players team (not pev anymore)
*		- code improvements (+)
*
* v1.3:
*	- fixed:
*		- again another default model bug (:P)
*		- red CC has now correct animation
*	- changes:
*		- code improvements
*
* v1.3.2b:
*	- fixed:
*		- dublicated red CC (during initialization and ingame)
*		- runtime error
*	- changes:
*		- moved from pev/set_pev to entity_get/entity_set
*
* v1.3.3:
*	- fixed:
*		- crash on some maps
*	- changes:
*		- code cleaning
*/

#include <amxmodx>
#include <amxmisc>
#include <engine>
#include <fakemeta>
#include <ns>

// change this to 1 to display the message when u spawn
#define disp_spawn_time 1

#define SPAWN_DELAY		2.0	// Per player in seconds
#define MAX_MULTIPLIER		6	// Maximum multiplier * SPAWN_DELAY (2*6+5=21 max spawn time)
#define FREE_LOOK		3
#define DEAD_RESPAWNABLE	3
#define HUD_CHANNEL		1

#define	NOTEAM			0
#define	MARINE			1
#define	MARINE2			2

enum {
	tNone,
	tAttacker,
	tDefender,
	tMarine2,
	tAlien2,
	tObserver
}

enum {
	PLAYERCLASS_NONE = 0,
	PLAYERCLASS_ALIVE_MARINE,
	PLAYERCLASS_ALIVE_ALIEN,
	PLAYERCLASS_ALIVE_JETPACK,
	PLAYERCLASS_ALIVE_HEAVY_MARINE,
	PLAYERCLASS_ALIVE_LEVEL1,
	PLAYERCLASS_ALIVE_LEVEL2,
	PLAYERCLASS_ALIVE_LEVEL3,
	PLAYERCLASS_ALIVE_LEVEL4,
	PLAYERCLASS_ALIVE_LEVEL5,
	PLAYERCLASS_ALIVE_DIGESTING,
	PLAYERCLASS_ALIVE_GESTATING,
	PLAYERCLASS_DEAD_MARINE,
	PLAYERCLASS_DEAD_ALIEN,
	PLAYERCLASS_COMMANDER,
	PLAYERCLASS_REINFORCING,
	PLAYERCLASS_SPECTATOR
}

enum {
	PLAYMODE_UNDEFINED = 0,
	PLAYMODE_READYROOM = 1,
	PLAYMODE_PLAYING = 2,
	PLAYMODE_AWAITINGREINFORCEMENT = 3,	// Player is dead and waiting in line to get back in
	PLAYMODE_REINFORCING = 4,		// Player is in the process of coming back into the game
	PLAYMODE_OBSERVER = 5
}

#define MAXTEAMS	6

new teamnames[MAXTEAMS][] = {
	"#undefinedteam",
	"Blue",
	"Yellow",
	"Green",
	"Red",
	"#spectatorteam"
}

new ccindex[4] = {0,0,0,0}
new Float:cclocation[3] = {0.0,0.0,0.0}

new g_maxplayers
new g_msgHudText2, g_msgScoreInfo
new Float:g_qstarttime[5], Float:g_spawntime[5]
new bool:g_spawning[5], bool:g_spawning2[5]
new g_ScoreInfo[33][7], player_team[33]
new Float:g_lasttimenotify
new is_mvm_game, AJrunning, combat_map, CC_2_id

new keyvalue_origin[32], keyvalue_teamchoice[32], keyvalue_angles[32], keyvalue_spawnflags[32]

new plugin_author[] = "White Panther"
new plugin_version[] = "1.3.3"

/* Init and forwards */
public plugin_init(){
	register_cvar("mvmallinone_version",plugin_version,FCVAR_SERVER)
	if ( is_mvm_game ){
		register_plugin("MvM_allinone",plugin_version,plugin_author)
		
		register_event("Countdown","eCountdown","ab")
		register_event("ResetHUD", "ePlayerSpawned", "b")
		register_event("TeamInfo","eTeamChanges","ab")
		register_event("TeamNames", "eFix_teams", "ab")
		
		
		register_think("team_command","command_think")
		// got probs when called immediatly (at least on AMXx)
		set_task(1.0,"initializecc",123)
		register_logevent("check_create",1)
		
		g_maxplayers = get_maxplayers()
		g_msgScoreInfo = get_user_msgid("ScoreInfo")
		g_msgHudText2 = get_user_msgid("HudText2")
		combat_map = ns_is_combat()
		
		register_message(g_msgScoreInfo, "editScoreInfo")
		register_message(g_msgHudText2, "editHudText2")
		register_message(get_user_msgid("SayText"), "editSayText")
		
		register_concmd("amx_mvm_auto","amx_mvm_auto",ADMIN_LEVEL_E,"<on/off> or <1/0> turns autoassign on or off")
		
		if ( combat_map )
			set_task(0.25, "checkStatus",_,_,_,"b")
			
	}else
		register_plugin("MvM_allinone (off)",plugin_version,plugin_author)
}

public plugin_modules(){
	require_module("engine")
	require_module("fakemeta")
	require_module("ns")
}

public plugin_precache(){
	register_forward(FM_Spawn, "Spawn")
}

public client_connect(id){
	if ( is_mvm_game )
		remove_task(5000+id)
}

public client_disconnect(id){
	if ( is_mvm_game )
		remove_task(5000+id)
}

public client_changeteam(id,newteam,oldteam){
	if ( is_mvm_game ){
		player_team[id] = NOTEAM
		remove_task(5000+id)
		if ( 1 <= newteam <= 4 )
			modelchange(id)
	}
}

public client_changeclass(id,newclass,oldclass){
	if ( is_mvm_game ){
		if ( is_user_connected(id) ){
			if ( newclass != 11 && newclass != 12 )
				modelchange(id)
		}
	}
}

public client_spawn(id){
	if ( is_mvm_game ){
		new model[64], team = entity_get_int(id,EV_INT_team)
		entity_get_string(id, EV_SZ_model, model, 63)
		if ( !equal("models/player.mdl", model) )
			return PLUGIN_HANDLED			// Fix for a possible exploit
		
		modelchange(id)					// set new model
		
		if ( g_ScoreInfo[id][5] == 0 || !g_spawning[team] || g_spawning2[team] )
			return PLUGIN_HANDLED			// They just came from the ready room, ignore them /  / Only set_task once, but give people time to spawn too
		
		g_spawning2[team] = true
		
		new team_to_pass[1]
		team_to_pass[0] = team
		set_task(0.2, "teamSpawnedReset", team,team_to_pass,1)		// Give people time to spawn
		remove_task(24338+team)				// Disable the backup system
	}
	
	return PLUGIN_HANDLED
}

public server_frame(){		// Because we changed the players class they can view both teams in spectator mode. Here we fix that
	if ( is_mvm_game && combat_map ){
		// get a list of all alive player from each team ( get_players(...) by team name does not work )
		new players[5][32], num[5]
		get_teamplayer_list(players,num)
		
		for ( new id = 1; id <= g_maxplayers; id++ ){
			if ( is_user_connected(id) ){
				//if ( entity_get_int(id, EV_INT_team) == 2 && !is_user_bot(id) ){
				if ( !is_user_bot(id) ){	// stop blue from specting red too, so involve them into checks
					if ( entity_get_int(id, EV_INT_deadflag) != DEAD_RESPAWNABLE )
						continue
					
					new viewingid = entity_get_int(id, EV_INT_iuser2)
					if ( is_user_connected(viewingid) ){
						if ( entity_get_int(viewingid, EV_INT_team) == entity_get_int(id, EV_INT_team) )
							continue
					}else
						continue
					
					new team = entity_get_int(id,EV_INT_team)
					if ( num[team] ){
						entity_set_int(id, EV_INT_iuser2, players[team][random(num[team])])	// Make them look at someone on their team
					}else{
						entity_set_int(id, EV_INT_iuser1, FREE_LOOK)			// Nobody to look at, look at the wall
						entity_set_int(id, EV_INT_iuser2, 0)
					}
				}
			}
		}
	}
}

public pfn_keyvalue(entid){
	new classname[32], key[32], value[32]
	copy_keyvalue(classname, 31, key, 31, value, 31)
	if ( !CC_2_id || entid == CC_2_id ){
		if ( equal(classname, "team_command") ){
			if ( equal(key, "origin") )
				copy(keyvalue_origin,31,value)
			else if ( equal(key, "teamchoice") ){
				if ( str_to_num(value) > 1 )
					CC_2_id = entid
				copy(keyvalue_teamchoice,31,value)
			}else if ( equal(key, "angles") )
				copy(keyvalue_angles,31,value)
			else if ( equal(key, "spawnflags") )
				copy(keyvalue_spawnflags,31,value)
		}
	}
	if ( is_mvm_game ){
		copy_keyvalue(classname, 31, key, 31, value, 31)
		
		if ( equal(key, "maxspawndistance") )
			DispatchKeyValue("maxspawndistance","9999")
	}
}

public Spawn(id){
	if( !is_valid_ent(id) )
		return PLUGIN_CONTINUE
	
	new classname[50]
	entity_get_string(id, EV_SZ_classname, classname, 49)
		
	if( equali(classname, "team_command") ){
		// fix for mvm where cc is team 2 instead of 3
		if ( entity_get_int(id,EV_INT_team) == 2 )
			entity_set_int(id,EV_INT_team,3)
		
		if ( entity_get_int(id,EV_INT_team) == 3 ){
			is_mvm_game = 1
			engfunc(EngFunc_PrecacheModel, "models/marinevsmarine/soldierb.mdl")
			engfunc(EngFunc_PrecacheModel, "models/marinevsmarine/soldierred.mdl")
			engfunc(EngFunc_PrecacheModel, "models/marinevsmarine/heavyblue.mdl")
			engfunc(EngFunc_PrecacheModel, "models/marinevsmarine/heavyred.mdl")
			engfunc(EngFunc_PrecacheModel, "models/marinevsmarine/b_armoryred.mdl")
			engfunc(EngFunc_PrecacheModel, "models/marinevsmarine/b_armoryredT.mdl")
			engfunc(EngFunc_PrecacheModel, "models/marinevsmarine/b_commandstationred.mdl")
			engfunc(EngFunc_PrecacheModel, "models/marinevsmarine/b_commandstationredT.mdl")
			engfunc(EngFunc_PrecacheModel, "models/marinevsmarine/b_armoryblue.mdl")
			engfunc(EngFunc_PrecacheModel, "models/marinevsmarine/b_armoryblueT.mdl")
			engfunc(EngFunc_PrecacheModel, "models/marinevsmarine/b_commandstationblue.mdl")
			engfunc(EngFunc_PrecacheModel, "models/marinevsmarine/b_commandstationblueT.mdl")
		}
	}
	return PLUGIN_CONTINUE
}

/* MvM_allinone */
public eCountdown(){
	if ( get_cvar_num("mp_ctgactive") != 1 )
		cc_armory_model_change("team_command","models/marinevsmarine/b_commandstationblue.mdl","models/marinevsmarine/b_commandstationred.mdl")
	
	cc_armory_model_change("team_armory","models/marinevsmarine/b_armoryblue.mdl","models/marinevsmarine/b_armoryred.mdl")
	
	return PLUGIN_HANDLED
}

public ePlayerSpawned(id){ 			// For detecting when a team has actually spawned after being set to REINFORCING class
	new team = entity_get_int(id, EV_INT_team)
	
	if ( AJrunning && ( team < 1 || team > 4 ) )
		client_cmd(id,"autoassign")
	
	return PLUGIN_HANDLED
}

public eTeamChanges(){
	new teamname[32], id = read_data(1)
	read_data(2,teamname,31)
	if ( equali(teamname,"marine1team") )
		player_team[id] = MARINE
	else if ( equali(teamname,"marine2team") )
		player_team[id] = MARINE2
}

public eFix_teams(id){
	message_begin(MSG_ONE,get_user_msgid("TeamNames"),{0,0,0},id)
	write_byte(MAXTEAMS)
	for( new i = 0; i < MAXTEAMS; i++ )
		write_string(teamnames[i])
	message_end()
}

public command_think(id){
	new count
	new entid = -1
	while ( ( entid = find_ent_by_class(entid,"team_command") ) > 0 ){
		if ( entity_get_int(entid,EV_INT_team) == 2 ){
			if ( entity_get_float(entid,EV_FL_health) > 0.0 ){
				if ( !(entity_get_int(entid,EV_INT_effects) & EF_NODRAW) )
					count++
			}
		}
	}
	if ( count == 0 ){
		entid = -1
		while ( ( entid = find_ent_by_class(entid,"team_command") ) > 0 ){
			if ( entity_get_int(entid,EV_INT_team) == 3 ){
				new Float:ent_health = entity_get_float(entid,EV_FL_health)
				if ( ent_health > 0.0 )
					fakedamage(entid,"trigger_hurt",ent_health + 10.0,0)
			}
		}
	}
	entity_set_float(id,EV_FL_nextthink,halflife_time() + 0.1)
}

public initializecc(){
	ccindex[0] = 0
	ccindex[1] = 0
	ccindex[2] = 0
	ccindex[3] = 0
	
	new entid = -1
	while ( ( entid = find_ent_by_class(entid,"team_command") ) > 0 )
		ccindex[entity_get_int(entid,EV_INT_team)] = entid
	
	if ( ccindex[2] )
		remove_entity(ccindex[2])
	
	entity_get_vector(ccindex[3],EV_VEC_origin,cclocation)
	
	new Float:nullbox[3]
	entity_set_vector(ccindex[3], EV_VEC_mins, nullbox)
	entity_set_vector(ccindex[3], EV_VEC_maxs, nullbox)
	entity_set_int(ccindex[3],EV_INT_effects, EF_NODRAW)
}

public check_create(){
	new szArg1[32]
	read_logargv(0,szArg1,31)
	if (szArg1[0] == 'G' && szArg1[1] == 'a' && szArg1[2] == 'm' && szArg1[3] == 'e' && szArg1[4] == ' ' && szArg1[5] == 'r' && szArg1[6] == 'e' && szArg1[7] == 's' && szArg1[8] == 'e' && szArg1[9] == 't' && szArg1[10] == ' ' && szArg1[11] == 'c' && szArg1[12] == 'o' && szArg1[13] == 'm' && szArg1[14] == 'p' && szArg1[15] == 'l' && szArg1[16] == 'e' && szArg1[17] == 't' && szArg1[18] == 'e' && szArg1[19] == '.' ){
		if ( AJrunning )
			autoassign_players()
		createcc()
	}
}

public editScoreInfo(){		// Replace Scoreboard "Reinforcing" with "DEAD" we will send "Reinforcing" ourselves
	new id = get_msg_arg_int(1)
	for ( new i = 0; i < 6; i++ )
		g_ScoreInfo[id][i] = get_msg_arg_int(i+2)
	
	if ( g_ScoreInfo[id][5] == tMarine2 || g_ScoreInfo[id][5] == tDefender ){
		set_msg_arg_int(7, get_msg_argtype(7), tAlien2)
		g_ScoreInfo[id][5] = tAlien2	// fix for green scoreboard while reinforcing
	}
}

public editHudText2(dummy,dummy2,receiver){	// Change "You are Spawning..." to "You are in a queue for reinforcing..." if they aren't actual about to spawn.
	if ( !is_user_connected(receiver) )
		return PLUGIN_CONTINUE
	
	new szMessage[64]
	get_msg_arg_string(1,szMessage,63)
	
	new szMsg[190]
	if ( equal(szMessage,"TeamOneWon") ){
		format(szMsg,189,"The Blue Team Won The Game!")
		set_msg_arg_string(1,szMsg)
	}else if ( equal(szMessage,"TeamTwoWon") ){
  		format(szMsg,189,"The Red Team Won The Game!")
		set_msg_arg_string(1,szMsg)
	}else if ( equal(szMessage,"GameDraw") ){
  		format(szMsg,189,"Tie Game!")
		set_msg_arg_string(1,szMsg)
	}
	
	if ( !equal(szMessage, "ReinforcingMessage") )
		return PLUGIN_CONTINUE
	
	if ( !g_spawning[entity_get_int(receiver, EV_INT_team)] )
		set_msg_arg_string(1, "ReinforcementMessage")
	
	return PLUGIN_CONTINUE
}

public editSayText(dummy,dummy2,receiver){	// Need to manually block team chat messages from going to the other team due to player class changes
	new fromid = get_msg_arg_int(1)
	if ( is_user_connected(fromid) ){
		new text[256]
		get_msg_arg_string(2, text, 255)
		
		if ( contain(text, "(TEAM)") != -1 ){
			if ( entity_get_int(fromid, EV_INT_team) != entity_get_int(receiver, EV_INT_team) )
				return PLUGIN_HANDLED
		}
	}
	
	return PLUGIN_CONTINUE
}

public amx_mvm_auto(id,level,cid){
	if (!cmd_access(id,level,cid,2))
		return PLUGIN_HANDLED
	
	new onoff[5]
	read_argv(1,onoff,4)
	if ( equal(onoff,"on") || equal(onoff,"1") ){
		if ( AJrunning == 1 ){
			console_print(id,"MvM Autoassign already enabled")
		}else{
			AJrunning = 1
			console_print(id,"MvM Autoassign enabled")
			//client_print(0,print_chat,"[AmxModX] Admin has turned on MvM Autoassign")
			autoassign_players()
		}
		return PLUGIN_HANDLED
	}
	if ( equal(onoff,"off") || equal(onoff,"0") ){
		if ( AJrunning == 0 ){
			console_print(id,"MvM Autoassign already disabled")
		}else{
			AJrunning = 0
			console_print(id,"MvM Autoassign disabled")
			//client_print(0,print_chat,"[AmxModX] Admin has turned off MvM Autoassign")
		}
		return PLUGIN_HANDLED
	}
	return PLUGIN_HANDLED
}

public checkStatus(){
	new numinqueue[5]
	
	for ( new id = 1; id <= g_maxplayers; id++ ){		// Stop people spawning and count how many there is in the queue
		if ( is_user_connected(id) ){
			if ( is_user_alive(id) || !is_valid_ent(id) )	// || entity_get_int(id, EV_INT_team) == 1 )
				continue
			
			new team = entity_get_int(id, EV_INT_team)
			
			if ( !( 1 <= team <= 4 ) || g_spawning[team] )
				continue
			
			new playerclass = entity_get_int(id, EV_INT_playerclass)
			
			if ( playerclass == PLAYMODE_AWAITINGREINFORCEMENT || playerclass == PLAYMODE_REINFORCING ){
				numinqueue[team]++
				if ( team == MARINE2 ){		// we are only checking blue team for players in spawn but dont want to respawn them manually
					entity_set_int(id, EV_INT_playerclass, PLAYMODE_OBSERVER)			// Changing their class stops them from spawning
					setSpecMode(id)							// The side effect is we have to set spectating
				}
			}else									// manually. (They can view both teams)
				numinqueue[team]++
		}
	}
	for ( new team = 1; team <= 4; team++ ){
		if ( numinqueue[team] > 0 ){
			numinqueue[team] = clamp(numinqueue[team], 1, MAX_MULTIPLIER)
			if ( g_qstarttime[team] == 0.0 )
				g_qstarttime[team] = get_gametime()
			
			new Float:spawndelay = numinqueue[team] * SPAWN_DELAY + 5
			
			g_spawntime[team] = (g_qstarttime[team] + spawndelay) - get_gametime() + 2.5
									// Have to add 2.5 to the end here otherwise as soon as a player
									// died he'd spawn straight away, and waves wouldn't happen
			
			if ( g_spawntime[team] <= 5.0 )		// Takes 5 seconds for NS to spawn a player after
				spawnPlayers(team)		// setting their class to REINFORCING
		}
	}
	
	if ( get_gametime() - g_lasttimenotify >= 0.75){	// Show time till spawn message once every 3/4 second
		g_lasttimenotify = get_gametime()
		displaySpawnTime(numinqueue)
	}
	
	return PLUGIN_HANDLED
}

/* additional Functions */
createcc(){
	ccindex[0] = 0
	ccindex[1] = 0
	ccindex[2] = 0
	ccindex[3] = 0
	
	new entid = -1
	while ( ( entid = find_ent_by_class(entid,"team_command") ) > 0 )
		ccindex[entity_get_int(entid,EV_INT_team)] = entid
	
	if ( ccindex[2] )
		remove_entity(ccindex[2])
	
	ccindex[2] = create_entity("team_command")
	
	DispatchKeyValue(ccindex[2],"origin",keyvalue_origin)
	DispatchKeyValue(ccindex[2],"teamchoice",keyvalue_teamchoice)
	DispatchKeyValue(ccindex[2],"angles",keyvalue_angles)
	DispatchKeyValue(ccindex[2],"spawnflags",keyvalue_spawnflags)
	
	DispatchSpawn(ccindex[2])
	copy_pevs(ccindex[3],ccindex[2])
	entity_set_int(ccindex[2],EV_INT_team,2)
	entity_set_origin(ccindex[2],cclocation)
	
	new Float:nullbox[3]
	entity_set_vector(ccindex[3], EV_VEC_mins, nullbox)
	entity_set_vector(ccindex[3], EV_VEC_maxs, nullbox)
	entity_set_int(ccindex[3],EV_INT_effects, EF_NODRAW)
}

#if defined disp_spawn_time
displaySpawnTime(numinqueue[]) {		// Display time to spawn info to dead players.
	for ( new id = 1; id <= g_maxplayers; ++id ){
		if ( !is_user_connected(id) )
			continue
		
		if ( entity_get_int(id, EV_INT_deadflag) != DEAD_RESPAWNABLE )
			continue
		
		new team = entity_get_int(id, EV_INT_team)
		
		if ( !( 1 <= team <= 4 ) )
			continue
		
		new deadtime[7]
		format(deadtime, 6, " + %.0f", SPAWN_DELAY)
		new calctext[128] = "5"
		
		for ( new i; i < numinqueue[team]; i++ )
			add(calctext, 127, deadtime)	// calctext = "5 + 2 + 2 + 2 + 2" 
		
		new hudtext[256]
		if ( g_spawning[team] ){
			if ( entity_get_int(id, EV_INT_playerclass) == PLAYMODE_REINFORCING ){
				format(hudtext, 255, "Time till spawn: Spawning^n(%.0f seconds per dead player) [max %d secs]",
					SPAWN_DELAY, floatround(MAX_MULTIPLIER*SPAWN_DELAY+5))
			}else{
				format(hudtext, 255, "Time till spawn: Waiting for next wave^n(%.0f seconds per dead player) [max %d secs]",
					SPAWN_DELAY, floatround(MAX_MULTIPLIER*SPAWN_DELAY+5))
			}
		}else
			format(hudtext, 255, "Time till spawn: %0.f^n(%.0f seconds per dead player) [max %d secs]^n%s", 
				g_spawntime[team]-2, SPAWN_DELAY, floatround(MAX_MULTIPLIER*SPAWN_DELAY+5), calctext)

		new is_marine = ( player_team[id] == MARINE )
		set_hudmessage(is_marine ? 0 : 200, is_marine ? 75 : 0, is_marine ? 100 : 0, 0.1, 0.1, 0, 0.0, 60.0, 0.0, 0.0, HUD_CHANNEL)
		show_hudmessage(id, hudtext)
	}
}
#endif

copy_pevs(source,target){
	new i
	// copy all strings
	new temp_str[128]
	for ( i = 0; i <= 12; i++ ){	// copying string number 1 will result in no model change
		entity_get_string(source,i,temp_str,127)
		entity_set_string(target,i,temp_str)
		temp_str[0] = 0
	}
	// copy all edicts
	for ( i = 0; i <= 10; i++ )
		entity_set_edict(target,i,entity_get_edict(source,i))
	
	// copy all floats
	for ( i = 0; i <= 36; i++ )
		entity_set_float(target,i,entity_get_float(source,i))
	
	// copy all integers
	for ( i = 0; i <= 36; i++ )
		entity_set_int(target,i,entity_get_int(source,i))
	
	// initial value is 1 or 2 so change manually to 3
	if ( combat_map )
		entity_set_int(target,EV_INT_sequence,3)
	else
		entity_set_int(target,EV_INT_team,2)
	
	// copy all bytes
	for ( i = 0; i <= 5; i++ )
		entity_set_byte(target,i,entity_get_byte(source,i))
	
	// copy all vecarrays
	new Float:temp_vec[3]
	for ( i = 0; i <= 22; i++ ){
		entity_get_vector(source,i,temp_vec)
		entity_set_vector(target,i,temp_vec)
	}
}

cc_armory_model_change(entity_name[],blue_model[],red_model[]){
	new cc_armory_id = -1
	while ( ( cc_armory_id = find_ent_by_class(cc_armory_id,entity_name) ) > 0 ){
		new Float:MinBox[3]
		new Float:MaxBox[3]
		new Float:orig[3]
		entity_get_vector(cc_armory_id, EV_VEC_origin, orig)
		entity_get_vector(cc_armory_id, EV_VEC_mins, MinBox)
		entity_get_vector(cc_armory_id, EV_VEC_maxs, MaxBox)
		if( entity_get_int(cc_armory_id, EV_INT_team) == 1 )
			entity_set_model(cc_armory_id,blue_model)
		else
			entity_set_model(cc_armory_id,red_model)
		entity_set_vector(cc_armory_id, EV_VEC_mins, MinBox)
		entity_set_vector(cc_armory_id, EV_VEC_maxs, MaxBox)
		entity_set_origin(cc_armory_id, orig)
		entity_set_int(cc_armory_id,EV_INT_solid,2)
	}
}

public modelchange_timer(timerid_id){
	new teamname[32], id = timerid_id - 5000
	get_user_team(id,teamname,31)
	if ( equali(teamname,"marine1team") )
		player_team[id] = MARINE
	else if ( equali(teamname,"marine2team") )
		player_team[id] = MARINE2
	
	modelchange(id)
}

modelchange(id){
	// if no teamname but in a team check in 0.1 secs again else stop
	if ( !player_team[id] ){
		set_task(0.1,"modelchange_timer",5000+id)
	}else{
		//ns_set_player_model(id) // reset
		if ( player_team[id] == MARINE ){
			if( ns_get_class(id) == 8 )
				ns_set_player_model(id,"models/marinevsmarine/heavyblue.mdl")
			else
				ns_set_player_model(id,"models/marinevsmarine/soldierb.mdl")
		}else if ( player_team[id] == MARINE2 ){
			if( ns_get_class(id) == 8)
				ns_set_player_model(id,"models/marinevsmarine/heavyred.mdl")
			else
				ns_set_player_model(id,"models/marinevsmarine/soldierred.mdl")
		}
	}
}

setSpecMode(id){	// Because we changed their class, they don't automatically go into spectator mode, so we do it manually.
	new players[5][32], num[5], team = entity_get_int(id,EV_INT_team)
	get_teamplayer_list(players,num)
	
	if ( num[team] ){
		entity_set_int(id, EV_INT_iuser1, 4)					// First Person Spectating
		entity_set_int(id, EV_INT_iuser2, players[team][random(num[team])])		// Player being spectated
	}
}

get_teamplayer_list(players[5][32],num[5]){
	for ( new i = 1; i <= g_maxplayers; i++ ){
		if ( is_user_connected(i) ){
			if ( is_user_alive(i) ){
				new team_i = entity_get_int(i,EV_INT_team)
				if ( 1 <= team_i <= 4 ){
					players[team_i][num[team_i]] = i
					num[team_i]++
				}
			}
		}
	}
	
}

spawnPlayers(team){
	g_spawning[team] = true				// Stop checking for dead players were in the middle of spawning people
	new team_to_pass[1]
	team_to_pass[0] = team
	set_task(5.0, "teamSpawnedReset", 24338+team,team_to_pass,1)	// Just incase for some reason we don't detect people spawning, this
									// is a backup that kicks in after 5 seconds if the team doesn't spawn.
	
	if ( team == MARINE2  ){			// only do this for red team
		for ( new id = 1; id <= g_maxplayers; id++ ){
			if ( is_user_connected(id) ){
				if ( entity_get_int(id, EV_INT_team) != team || is_user_alive(id) )
					continue
				
				if ( entity_get_int(id, EV_INT_playerclass) == PLAYMODE_OBSERVER ){		// OBSERVER is what we set them to so they don't spawn.
					entity_set_int(id, EV_INT_playerclass, PLAYMODE_REINFORCING)
					sendReinforcing(id)					// Update the scoreboard with "Reinforcing".
					new Userid[1]
					Userid[0] = id
					set_task(0.1, "sendReinforcingTT", id,Userid,1)		// Weird I have to call this function externally.
				}								// I don't think AMXMod can handle sending 2
			}									// messages in the same function
		}
	}
}

public sendReinforcing(id){	// Update the Score board with the "Reinforcing"
	message_begin(MSG_ALL, g_msgScoreInfo)
	write_byte(id)
	write_short(g_ScoreInfo[id][0])
	write_short(g_ScoreInfo[id][1])
	write_short(g_ScoreInfo[id][2])
	write_byte(PLAYERCLASS_REINFORCING)
	write_short(g_ScoreInfo[id][4])
	write_short(g_ScoreInfo[id][5])
	message_end()
}

autoassign_players(){
	for ( new id = 1; id <= g_maxplayers; id++ ){
		if ( is_user_connected(id) ){
			if ( !entity_get_int(id, EV_INT_team) )
				engclient_cmd(id,"autoassign")
		}
	}
}

/* Timer Functions */
public teamSpawnedReset(team[]){
	if ( team[0] > 24338 )
		team[0] -= 24338		// For the backup system
	
	g_qstarttime[team[0]] = 0.0
	g_spawning[team[0]] = false	// Enable checking for dead players again, the spawning is over
	g_spawning2[team[0]] = false
}

public sendReinforcingTT(id[]){
	message_begin(MSG_ONE, g_msgHudText2,{0,0,0},id[0])
	write_string("ReinforcingMessage")
	write_byte(1)
	message_end()
}